// -------------------------------------------------------------------
//                        ExCapture Ver.0.1.4
//                     rfILv`Cu
// -------------------------------------------------------------------
// 
// ExCapture
// The MIT License
// Copyright (c) 2009 Hirofumi Uemura and Sunao Hashimoto
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//
//
// ExCapture
// MITCZX
// Copyright (c) 2009 Hirofumi Uemura and Sunao Hashimoto
//
// ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tg
// EFAvj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ
// ŋ܂Bɂ́A\tgEFA̕gpAʁAύXAAfځA
// ЕzATuCZXA/܂͔̔錠Aу\tgEFA񋟂
// ɓƂ錠Ɋ܂܂܂B 
//
// L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕ
// ɋLڂ̂Ƃ܂B 
// 
// \tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ
// Ȃ񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KA
// NQɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂B 
// ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\tg
// EFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈
// Đ؂̐AQȂ̋`ɂĉ̐ӔCȂ
// Ƃ܂B 
//
//
// WindowsŎgrfILv`CułD
// DirectShowgďĂ܂D
// USBJrfILv`J[hȒPɉ摜擾邱Ƃł܂D
// [Upӂobt@ɑ΂ĉ摜̃sNZf[^ԂƂł܂D
// OpenCVŗpIplImage`ɂΉĂ܂D
// J̖邳zCgoX𐧌䂷邱Ƃł܂D
// Logitech Qcam Orbit AF Ƃp`gJ̐ł܂D
// 
// Logitech Qcam Orbit AF (QCAM-200R)̃JjJp`gɊւ
// http://www.quickcamteam.net/documentation/how-to/how-to-control-pan-tilt-zoom-on-logitech-cameras/


#ifndef __EX_CAPTURE_H__
#define __EX_CAPTURE_H__


#define USE_OPENCV // OpenCVgȂȂ炱̍sRgAEg

#pragma once
#pragma warning(disable:4996)	//strsafe.hɊւx΍
#pragma warning(disable:4819)	//uuids.hɊւx΍

// OpenCVgȂȂ炱RgAEg
	#include <cxcore.h>
	#include <cv.h>
	#include <highgui.h>
	#pragma comment(lib,"cxcore.lib")
	#pragma comment(lib,"cv.lib")
	#pragma comment(lib,"highgui.lib")
// OpenCVgȂȂ܂ŃRgAEg

#include <dshow.h>
#include <qedit.h>
#include <math.h>	//for floor()

//Qcam Orbit AF pɕKvȃwb_----------------------------------------------------------

#include <Ks.h>		 // Required by KsMedia.h
#include <KsMedia.h> // For KSPROPERTY_CAMERACONTROL_FLAGS_*
#pragma comment(lib,"strmiids.lib")
#pragma comment(lib,"Quartz.lib")


// ExImageNXev[gi錾̂݁j
template <typename type> class ExImage;

//摜tH[}bg`p萔------------------------------------------------------------------
#ifndef MEDIA_TYPE
#define MEDIA_TYPE MEDIASUBTYPE_RGB24
//MEDIA_TYPE̒lɂĉ摜tH[}bgς
//ɂ(JɂĎgp\ȃtH[}bg͈قȂ)
//MEDIASUBTYPE_RGB4
//MEDIASUBTYPE_RGB8
//MEDIASUBTYPE_RGB565
//MEDIASUBTYPE_RGB555
//MEDIASUBTYPE_RGB24
//MEDIASUBTYPE_RGB32
//MEDIASUBTYPE_ARGB32
#endif


//foCXݒp萔--------------------------------------------------------------------------
#define EXC_VPAMPMAX	10
#define EXC_CAMCTLMAX	7
#define EXC_ITEMMAX		(EXC_VPAMPMAX+EXC_CAMCTLMAX)

//IAMVideoProcAmp
#define EXC_BRIGHTNESS				0
#define EXC_CONTRAST				1
#define EXC_HUE						2
#define EXC_SATURATION				3
#define EXC_SHARPNESS				4
#define EXC_GAMMA					5
#define EXC_COLORENABLE				6
#define EXC_WHITEBALANCE			7
#define EXC_BACKLIGHTCOMPENSATION	8
#define EXC_GAIN					9

//IAMCameraControl
#define EXC_PAN						10
#define EXC_TILT					11
#define EXC_ROLL					12
#define EXC_ZOOM					13
#define EXC_EXPOSURE				14
#define EXC_IRIS					15
#define EXC_FOCUS					16

//萔}N----------------------------------------------------------------------------------
#define EXC_SUCCESS		 0	// 
#define EXC_ERROR		-1	// G[
#define EXC_NO_DEVICE	-2	// foCXȂ
#define EXC_CANCEL		-3	// LZꂽ

//z錾ɎgpĂ萔
#define EXC_MAX_DEV_NUM		10	// ő̃Jԍ
#define EXC_MAX_PIN_NUM		10	// s̍ő吔
#define EXC_STR_LENGTH		512	// ̒̍ől


//foCX̃s\--------------------------------------------------------------------
typedef struct tagPINDATA {
	int		nOutput;						// o̓s
	int		nInput;							// ̓s
	long	TypeOutput[EXC_MAX_PIN_NUM];	// o̓s̃^Cv
	long	TypeInput[EXC_MAX_PIN_NUM];		// ̓s̃^Cv
} PINDATA;	


//R[obN֐̃NX` ---------------------------------------------------------------
class Cap_SampleGrabberCB :public ISampleGrabberCB{
public:
	double tm;
	// O[oϐgpȂ߂̃oϐ
	int *pbuf_CB;
	volatile long *bufsize_CB;
	volatile double *time_CB;
	int wx_CB;
	int wy_CB;

	Cap_SampleGrabberCB();	// RXgN^
	~Cap_SampleGrabberCB();	// fXgN^

	STDMETHODIMP_(ULONG) AddRef();
	STDMETHODIMP_(ULONG) Release();
	STDMETHODIMP QueryInterface( REFIID riid, void **ppv );
	STDMETHODIMP SampleCB( double SampleTime, IMediaSample *pSample );
	STDMETHODIMP BufferCB( double dblSampleTime, BYTE *pBuffer, long lBufferSize );	// t[ɌĂ΂֐

	void TimeSet( double *t );
	int IsCaptured();
};



// DirectShow֌W̃f[^܂Ƃ߂\ ----------------------------------------------------
typedef struct tagDSHOWDATA{
	char					DeviceName[EXC_STR_LENGTH];	// foCX
	BITMAPINFO				Bmi;						// BITMAPINFO\					
	PINDATA					PinData;					// s\					
	ISampleGrabber			*pSampleGrabber;			// TvOo
	ICaptureGraphBuilder2	*pCaptureGraphBuilder2;		// Lv`Otr_
	IBaseFilter				*pDeviceFilter;				// foCXtB^
	IBaseFilter				*pSampleGrabberFilter;		// TvOotB^
	IBaseFilter				*pVideoRenderer;			// rfI_
	IAMVideoProcAmp			*pIAMVideoProcAmp;			// rfIvZXAv
	IAMCameraControl		*pIAMCameraControl;			// JRg[
	IAMStreamConfig			*pIAMStreamConfig;			// Xg[RtBO
	IAMCrossbar				*pCrossbar;					// NXo[
	BOOL					StreamPropertyIsBusy;		// Xg[`̃vpeB\
	Cap_SampleGrabberCB		SampleGrabberCB;			// R[obNp֐
	double					fps;						// t[[g
	int						*pbuf;						// 摜obt@̃AhX
	int						*buffer;					// 摜obt@̎
	volatile long			bufsize;					// 摜obt@TCY
	volatile double			time;						// 摜擾̎
	int						valueflag[EXC_ITEMMAX];		// ݒ荀ڂ̗L/̃tO
} DSHOWDATA;


//ewclibNXExCaptureNX
class ExCapture {
private:

	int					m_flag_open;				// foCX(I[v)ς݂ǂ̃tO
	int					m_use_num;					// gp\ȃfoCX
	IGraphBuilder		*m_pGraphBuilder;			// Otr_
	IMediaControl		*m_pMediaControl;			// fBARg[	
	DSHOWDATA			m_dshow[EXC_MAX_DEV_NUM];		// DirectShow֌W̃f[^܂Ƃ߂\
	HRESULT				m_hr;						// DirectShow֌W̊֐Ő/sԂlpϐ

	//֐
	void	dsInit( DSHOWDATA &dshow );											// DSHOWDATA\̂̏
	void	dsRelease( DSHOWDATA &dshow );										// DSHOWDATA\̗̂̈
	void	dsGetDeviceName( IMoniker *pMoniker, char DeviceName[] );			// jJ̃foCX̎擾
	int		dsGetDevice( DSHOWDATA dshow[], int n_request, bool flag_choose_device=false );	// Lv`foCX̎擾
	int		dsSetDevice( DSHOWDATA &dshow, int id, int width, int height, double fps, bool flag_choose_prop=false ); // jJ̃foCXݒ
	void	dsSetSGformat( DSHOWDATA &dshow );									// TvOõtH[}bgݒ
	int		dsGetCrossBar( DSHOWDATA &dshow );									// NXo[̐ݒ
	int		dsShowStreamProperty( DSHOWDATA &dshow, bool flag_choose_prop=false );	// Xg[`̃vpeB\
	void	dsGetBmi( DSHOWDATA &dshow );										// rbg}bv̎擾
	IPin*	dsGetPin( IBaseFilter *pFilter, PIN_DIRECTION PinDir );				// tB^̃s擾

public:

	ExCapture();	// RXgN^
	~ExCapture();	// fXgN^

	int		Open( int n_request = 1, int width=320, int height=240, double fps=30.0,
				   bool flag_choose_device=false, bool flag_choose_prop=false ); // foCX̃I[v
	int		Close( void );				// foCX̃N[Y
	int		IsOpened( void );			// foCXI[vĂ邩mF
	int		NumAvailable( void );		// gp\ȃJԂ
	int		NumCheck( int id );			// JԍLǂ`FbN

	int		SetVideoProperty( int id, int width, int height, double fps, bool flag_choose_prop=false );	// rfI͂̐ݒ(𑜓xƂ)
	int		SetVideoImageProperty( int id ); // rfI͂̐ݒ(邳Ƃ)_CAO\Đݒ

	void	GetBmi( int id, BITMAPINFO *bmi );				// rbg}bv̎擾
	void	GetDeviceName( int id, char name[] );			// foCX̎擾
	void	GetPinData( int id, PINDATA *PinData );			// s̎擾

// fɊւ郁o֐Q----------------------------------------------------------------------------------------
	double	GetValue( int id, int prop, int *mode=NULL );	// ݒlǂݏo
	int		SetValue( int id, int prop, double value );		// 蓮ɂCݒlύX
	int		SetDefault( int id, int prop );					// ݒlɖ߂
	int		SetAuto( int id, int prop );					// [hɂ
	int		SetManu( int id, int prop );					// 蓮[hɂCݒl݂͌̒lp
	int		PropIsAvailable( int id, int prop );			// ݒ荀ڂLǂׂ

// ȍ~́C₷邽߂̃bvo֐--------------------------------------------------------------
	int		SetBrightnessAuto( int id );					// 邳[hɂ
	int		SetBrightnessManu( int id );					// 邳蓮[hɂ
	int		SetBrightness( int id, double value );			// 邳蓮[hɂāCݒlύX
	double	GetBrightness( int id );						// 邳̐ݒlǂݏo

	int		SetContrastAuto( int id );						// RgXg[hɂ
	int		SetContrastManu( int id );						// RgXg蓮[hɂ
	int		SetContrast( int id, double value );			// RgXg蓮[hɂāCݒlύX
	double	GetContrast( int id );							// RgXg̐ݒlǂݏo

	int		SetSaturationAuto( int id );					// ʓx[hɂ
	int		SetSaturationManu( int id );					// ʓx蓮[hɂ
	int		SetSaturation( int id, double value );			// ʓx蓮[hɂāCݒlύX
	double	GetSaturation( int id );						// ʓx̐ݒlǂݏo

	int		SetWhitebalanceAuto( int id );					// zCgoX[hɂ
	int		SetWhitebalanceManu( int id );					// zCgoX蓮[hɂ
	int		SetWhitebalance( int id, double value );		// zCgoX蓮[hɂāCݒlύX
	double	GetWhitebalance( int id );						// zCgoX̐ݒlǂݏo

	int		SetIrisAuto( int id );							// ڂ蒲[hɂ
	int		SetIrisManu( int id );							// ڂ蒲蓮[hɂ
	int		SetIris( int id, double value );				// ڂ蒲蓮[hɂāCݒlύX
	double	GetIris( int id );								// ڂ蒲̐ݒlǂݏo

	int		SetFocusAuto( int id );							// tH[JX[hɂ
	int		SetFocusManu( int id );							// tH[JX蓮[hɂ
	int		SetFocus( int id, double value );				// tH[JX蓮[hɂāCݒlύX
	double	GetFocus( int id );								// tH[JX̐ݒlǂݏo

// fɊւ֐Q ܂--------------------------------------------------------------------------------------

	int		Width( int id );								// 摜̉TCYԂ
	int		Height( int id );								// 摜̏cTCYԂ
	double	FPS( int id );									// t[[gԂ
	int		SizeImage( int id );							// t[obt@TCY(P:oCg)Ԃ
	int		GetBufferAddress( int id, void **buffer );		// ݂̃obt@AhX擾
	int		SetBufferAddress( int id, void *buffer );		// obt@AhXύX

// 摜擾Ɋւ֐-------------------------------------------------------------------------------------------------
	int		GetImage( int id, void *buffer );				// J̉摜擾
	int		IsCaptured( int id, double *t=NULL );			// V摜ǂ

#ifdef _CXCORE_H_
	int		GetImage( int id, IplImage **image );			// J摜̎擾
	int		CreateImage( int id, IplImage **image );		// 摜obt@̊m
#endif

	template <typename type> int GetImage( int id, ExImage <type> & image ) {
		// ev[gȂ̂Ńwb_Ɏ
		return GetImage( id, &(image.Ipl()) );
	}
	template <typename type> void CreateImage( int id, ExImage <type> & image ) {
		// ev[gȂ̂Ńwb_Ɏ
		return image.Create( Width(id), Height(id) );
	}

// Qcam Orbit AF ̃JjJp`gɊւ֐-----------------------------------------------------------------
	int		OrbitResetPanTlt( int id );						// p`gʒuZbg(4bقǂ)
	int		OrbitSetPanRelative( int id, int pos );			// ΓIpʒuZbg
	int		OrbitSetTltRelative( int id, int pos );			// ΓI`gʒuZbg

	void	GetLastMessage( char *s, int size );	// Ō̃G[bZ[W擾
};


#endif


